//========================================================
//HI-MD Renderer Application - Windows Main function
//
//Written by Mark Collier.
//http://www.marcnetsystem.co.uk/
//
//This program is freeware and may be distributed in part or 
//in whole as long as a the author is credited clearly some way in 
//both the source code and in some visible way when the program 
//is running (eg:in a help screen or version info screen ).

//This notice must also appear in any source file that contains
//any part of the code in this file. 

//I (the author) take no responsability for the loss, transfer, corruption
//duplication, modification, or addition of legal or illegal data in any way. 
//
//Thanks for reading

//TO BUILD THIS YOU WILL NEED MICROSOFT DIRECTX SDK. 
//DOWNLOAD IT FROM THEM BEFORE EVEN ATTEMPTING TO BUILD THIS!

//MarC
//=========================================================

#include <windows.h>
#include <stdio.h>
#include "internal.h"

//=========================================================

#define HIMDRENDERCLASSNAME "HiMdRenderApplication"
#define HIMDRENDERTITLE		"MarC's HiMdRenderer - version 0.07 - http://www.marcnetsystem.co.uk/himd/"
#define HIMDRENDERERERROR   "HiMdRenderer - ERROR"
#define HIMDRENDERERMSG		"HiMdRenderer"
#define RENDERBUTTON_OK		"GO RENDER!"
#define RENDERBUTTON_BUSY	"Please Wait..."

#define DEFAULT_WND_WIDTH	700
#define DEFAULT_WND_HEIGHT	430

#define HIMDRENDER_GO		(WM_USER + 100)
#define HIMDRENDER_BATCH	(WM_USER + 102)

//=========================Globals===========================
static char lpstrInFile[255];
static char lpstrOutFile[255];
static BOOL bProcessing = FALSE;
static BOOL bBatchMode = FALSE;

//window handles
static HWND hwndFileList = NULL;
static HWND hwndAddFile = NULL;
static HWND hwndDelFile = NULL;
static HWND hwndMode = NULL;
static HWND hwndInputBrowse = NULL;
static HWND hwndOutputBrowse = NULL;
static HWND hwndInputFile = NULL;
static HWND hwndOutputFile = NULL;
static HWND hwndButton = NULL;
static HWND hwndSmoAvg = NULL;
static HWND hwndSmoAnl= NULL;

//========================Callbacks======================================
static void WindowMsgCallback(MARCWNDDATA mwnddata,HWND hwnd,int iMsg,WPARAM wparam,LPARAM lparam,LPVOID lpvParam)
{
	char lpstrTmpFile[255];
	char errbuffer[1024];
	char tmp[255];
	int iRet,iIndex;

	if(bBatchMode)
	{
		//get first item in list
		iIndex = (int)wparam;
		if(!MWNDGetItemListText(hwndFileList,iIndex,lpstrInFile))
		{
			bProcessing = FALSE;
			EnableWindow(hwnd,TRUE);
			MessageBox(0,"All Files Processed!",HIMDRENDERERMSG, MB_OK | MB_ICONINFORMATION|  MB_SETFOREGROUND);
			DeinitCore();
			MWNDSetText(hwndButton,RENDERBUTTON_OK);
			return;
		}
	}
	
	switch(iMsg)
	{
		case HIMDRENDER_BATCH:
			iRet = MWNDGetListCount(hwndFileList);
			sprintf(errbuffer,"Processing %u of %u",iIndex+1,iRet);
			MWNDSetText(hwndButton,errbuffer);

			ChangeLogFile(lpstrInFile);

			//make temp filename
			strcpy(lpstrTmpFile,lpstrInFile);
			strcat(lpstrTmpFile,".tmp");
			strcpy(lpstrOutFile,lpstrInFile);
			strcat(lpstrOutFile,".wav");
			
			//convert
			iRet = DoCoreConversion(lpstrInFile,lpstrTmpFile,lpstrOutFile,errbuffer);

			if(iRet != 0 )
			{
				if(errbuffer[0] == 0)
				{
					sprintf(errbuffer,"An unknown error occured");
				}

				sprintf(tmp,"%s processing file %s",HIMDRENDERERERROR,lpstrInFile);
				MessageBox(0,errbuffer,tmp, MB_OK | MB_ICONEXCLAMATION |  MB_SETFOREGROUND);
			}
			
			PostMessage(hwnd,HIMDRENDER_BATCH,iIndex+1,0);
		
			break;

		case HIMDRENDER_GO:			
			//init
			memset(errbuffer,0,sizeof(errbuffer));
			InitCore(lpstrInFile);

			if(bBatchMode)
			{
				iRet = MWNDGetListCount(hwndFileList);
				MWNDSetText(hwndButton,errbuffer);
				PostMessage(hwnd,HIMDRENDER_BATCH,0,0);
				return;
			}

			//make temp filename
			strcpy(lpstrTmpFile,lpstrInFile);
			strcat(lpstrTmpFile,".tmp");
			
			//convert
			iRet = DoCoreConversion(lpstrInFile,lpstrTmpFile,lpstrOutFile,errbuffer);

			DeinitCore();
			if(iRet != 0 )
			{
				if(errbuffer[0] == 0)
				{
					sprintf(errbuffer,"An unknown error occured");
				}

				MessageBox(0,errbuffer,HIMDRENDERERERROR, MB_OK | MB_ICONEXCLAMATION |  MB_SETFOREGROUND);
			}
			else
			{
				MessageBox(0,"File converted!",HIMDRENDERERMSG, MB_OK | MB_ICONINFORMATION|  MB_SETFOREGROUND);
			}

			bProcessing = FALSE;
			EnableWindow(hwnd,TRUE);
			MWNDSetText(hwndButton,RENDERBUTTON_OK);
			break;
		default:
			break;
	}
}

static void WindowEventCallback(MARCWNDDATA mwnddata,HWND hwnd,DWORD dwMsg,LPVOID lpvParam1,LPVOID lpvParam2)
{
	DWORD dwValue;
	char errbuffer[1024];
	char lpstrFile[255];
	LPSTR tempbuf;

	switch((DWORD)lpvParam2)
	{
		case 0:
			if((hwnd == hwndAddFile)&& (!bProcessing))
			{
				bProcessing = TRUE;
				memset(lpstrFile,0,sizeof(lpstrFile));
				tempbuf = (LPSTR)LocalAlloc(LPTR,MAX_PATH * 10000);
				if(GetInputFileFromAWindow(tempbuf,MAX_PATH * 10000))
				{
					dwValue = 0;
					while(tempbuf[dwValue] != 0)
					{
						if(strchr(tempbuf + dwValue,'\\') != NULL)
						{
							strcpy(lpstrFile,tempbuf + dwValue);

							if(CheckFileIsOK(lpstrFile,FALSE))
							{
								MWNDAddToList(hwndFileList,lpstrFile,0,FALSE);
							}
							else
							{
								strcat(lpstrFile,"\\");
							}
						}
						else
						{
							*(strrchr(lpstrFile,'\\')+1) = 0;
							strcat(lpstrFile,tempbuf + dwValue);
							MWNDAddToList(hwndFileList,lpstrFile,0,FALSE);
						}
						
						dwValue += strlen(tempbuf+dwValue) + 1;
					}
				}
				LocalFree(tempbuf);
				bProcessing = FALSE;
			}
			else if((hwnd == hwndDelFile)&& (!bProcessing))
			{
				MWNDDelFromList(hwndFileList,-1);
			}
			else if ((hwnd == hwndMode) && (!bProcessing))
			{
				if(!bBatchMode)
				{
					ShowWindow(hwndFileList,SW_SHOW);
					ShowWindow(hwndAddFile,SW_SHOW);
					ShowWindow(hwndDelFile,SW_SHOW);
					ShowWindow(hwndInputBrowse,SW_HIDE);
					ShowWindow(hwndOutputBrowse,SW_HIDE);
					ShowWindow(hwndInputFile,SW_HIDE);
					ShowWindow(hwndOutputFile,SW_HIDE);
					SetWindowText(hwndMode,"File Mode");
					bBatchMode= TRUE;
				}
				else
				{
					ShowWindow(hwndFileList,SW_HIDE);
					ShowWindow(hwndDelFile,SW_HIDE);
					ShowWindow(hwndAddFile,SW_HIDE);
					ShowWindow(hwndInputBrowse,SW_SHOW);
					ShowWindow(hwndOutputBrowse,SW_SHOW);
					ShowWindow(hwndInputFile,SW_SHOW);
					ShowWindow(hwndOutputFile,SW_SHOW);
					SetWindowText(hwndMode,"Batch Mode");
					bBatchMode = FALSE;
				}
			}
			else if((hwnd == hwndInputBrowse)&& (!bProcessing))
			{
				bProcessing = TRUE;
				if(GetInputFileFromAWindow(lpstrInFile,sizeof(lpstrInFile)))
				{
					strcpy(lpstrOutFile,lpstrInFile);
					strcat(lpstrOutFile,".wav");
					MWNDSetText(hwndInputFile,lpstrInFile);
					MWNDSetText(hwndOutputFile,lpstrOutFile);
				}
				bProcessing = FALSE;
			}
			else if ((hwnd == hwndOutputBrowse) && (!bProcessing))
			{
				bProcessing = TRUE;
				if(GetSaveFileFromAWindow(lpstrOutFile,sizeof(lpstrOutFile)))
				{
					MWNDSetText(hwndOutputFile,lpstrOutFile);
				}
				bProcessing = FALSE;
			}
			else if((hwnd == hwndButton) && (!bProcessing))
			{	//get input/outfile files
				memset(lpstrInFile,0,sizeof(lpstrInFile));
				memset(lpstrOutFile,0,sizeof(lpstrOutFile));
				MWNDGetText(hwndInputFile,lpstrInFile,sizeof(lpstrInFile));
				MWNDGetText(hwndOutputFile,lpstrOutFile,sizeof(lpstrOutFile));

				//check settings
				if(bBatchMode)
				{	
					bProcessing = TRUE;
					MWNDSetText(hwndButton,RENDERBUTTON_BUSY);
					PostMessage(MWNDGetHWND(mwnddata),HIMDRENDER_GO,0,0);
				}
				else if((lpstrInFile[0] == 0) || (!CheckFileIsOK(lpstrInFile,FALSE)))
				{
					MessageBox(0,"Invalid Input File!",HIMDRENDERERERROR, MB_OK | MB_ICONEXCLAMATION |  MB_SETFOREGROUND);
				}
				else if((lpstrOutFile[0] == 0) || (!CheckFileIsOK(lpstrOutFile,TRUE)))
				{
					MessageBox(0,"Invalid Destination File!",HIMDRENDERERERROR, MB_OK | MB_ICONEXCLAMATION |  MB_SETFOREGROUND);
				}
				else if(CheckSettings(errbuffer) != 0)
				{
					MessageBox(0,errbuffer,HIMDRENDERERERROR, MB_OK | MB_ICONEXCLAMATION |  MB_SETFOREGROUND);
				}
				else
				{	//all checks ok... lets do it,
					bProcessing = TRUE;
					MWNDSetText(hwndButton,RENDERBUTTON_BUSY);
					PostMessage(MWNDGetHWND(mwnddata),HIMDRENDER_GO,0,0);
				}
			}
			break;
		case 1:	//tick boxes
			dwValue = GetSetting((DWORD)lpvParam1);
			switch((DWORD)lpvParam1)
			{	
				case SETTING_ENABLESMOOOTHING:
					EnableWindow(hwndSmoAvg, !dwValue  );
					EnableWindow(hwndSmoAnl, !dwValue );
					MWNDSetCheckedState(hwnd,!dwValue );
					SetSetting((DWORD)lpvParam1, !dwValue);
					break;
				default:
					SetSetting((DWORD)lpvParam1, !dwValue);
					MWNDSetCheckedState(hwnd,!dwValue);
					break;
			}
			break;
		case 2:	//numbers
			dwValue = MWNDGetTextNumber(hwnd);
			switch((DWORD)lpvParam1)
			{
				case SETTING_SKIPSIZE:
					SetSetting((DWORD)lpvParam1, dwValue * 10000);
					break;
				default:
					SetSetting((DWORD)lpvParam1, dwValue);
					break;
			}
			break;

	}
}

//=====================WinMain==========================================

int __stdcall WinMain(HINSTANCE hinst,HINSTANCE hprev,LPSTR cmd,int ishow)
{
	MARCWNDDATA mwndMainWindow;
	HWND hwnd;
	int y,i;
	struct _topts { DWORD opt;LPSTR desc; }tickopts[] = 
	{
		SETTING_KEEPTMPFILE , "Keep Temporary File", 
		SETTING_DEBUG,		  "Generate Log File",
		SETTING_USEAVGING,	  "Use average offsets",
		SETTING_NOIGNORELONGRPTS, "Don't ignore larger than average blocks",
		SETTING_ENABLESMOOOTHING , "Enable Smoothing"
	};

	struct _nopts { DWORD opt;LPSTR desc;}numopts[] = 
	{
		SETTING_BLOCKSIZE	, "Block size (in seconds)",
		SETTING_SKIPSIZE	, "Overlap size (in milliseconds)",
		SETTING_ALLOWEDDIFF , "Maximum allowed byte difference",
		SETTING_SMOOTH_ANALYSIS_WINDOW, "Smoothing analysis window size",
		SETTING_SMOOTH_AVGING_WINDOW, "Smoothing averaging window size",
	};


	mwndMainWindow = MWNDRegisterClass(hinst,HIMDRENDERCLASSNAME);
	if (mwndMainWindow == NULL)
	{
		return -1;
	}

	//create window
	if(!MWNDStartWindow(mwndMainWindow,DEFAULT_WND_WIDTH,DEFAULT_WND_HEIGHT,HIMDRENDERTITLE))
	{
		return -2;
	}
	
	hwndFileList = MWNDAddControl(mwndMainWindow,CONTROLTYPE_LISTBOX,0,5,300 ,DEFAULT_WND_HEIGHT - 30,0,
								  CONTROLRESIZE_RESIZEHEIGHT | CONTROLRESIZE_RESIZEWIDTH,
								  WindowEventCallback,0,0);

	MWNDSetControlFont(mwndMainWindow,hwndFileList,14,7,FALSE,FALSE,"Courier new");

	hwndAddFile = MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,302,5,100,20,
									 "Add Files",CONTROLRESIZE_MOVEX,WindowEventCallback,0,0);
	MWNDSetControlFont(mwndMainWindow,hwndAddFile,16,8,FALSE,FALSE,"Courier new");

	hwndDelFile = MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,302,30,100,20,
									 "Remove File",CONTROLRESIZE_MOVEX,WindowEventCallback,0,0);
	MWNDSetControlFont(mwndMainWindow,hwndDelFile,16,8,FALSE,FALSE,"Courier new");


	
	//add the controls for "input file"
	hwnd = MWNDAddControl(mwndMainWindow,CONTROLTYPE_STATIC,1,12,100,20,"Input File:",0,NULL,0,0);
	hwndInputFile =   MWNDAddControl(mwndMainWindow,CONTROLTYPE_EDITBOX,110,10,400,20,
									 "",CONTROLRESIZE_RESIZEWIDTH ,NULL,0,0);
	hwndInputBrowse = MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,510,10,80,20,
									 "Browse...",CONTROLRESIZE_MOVEX,WindowEventCallback,0,0);
	
	MWNDSetControlFont(mwndMainWindow,hwndInputFile,16,8,FALSE,FALSE,"Courier new");
	MWNDSetControlFont(mwndMainWindow,hwndInputBrowse,16,8,FALSE,FALSE,"Courier new");
	MWNDSetControlFont(mwndMainWindow,hwnd,16,8,FALSE,FALSE,"Courier new");

	//add the controls for "output file"
	hwnd = MWNDAddControl(mwndMainWindow,CONTROLTYPE_STATIC,1,42,100,20,"Output File:",0,NULL,0,0);
	hwndOutputFile =   MWNDAddControl(mwndMainWindow,CONTROLTYPE_EDITBOX,110,40,400,20,
									 "",CONTROLRESIZE_RESIZEWIDTH ,NULL,0,0);
	hwndOutputBrowse = MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,510,40,80,20,
									 "Browse...",CONTROLRESIZE_MOVEX,WindowEventCallback,0,0);
	MWNDSetControlFont(mwndMainWindow,hwndOutputFile,16,8,FALSE,FALSE,"Courier new");
	MWNDSetControlFont(mwndMainWindow,hwnd,16,8,FALSE,FALSE,"Courier new");
	MWNDSetControlFont(mwndMainWindow,hwndOutputBrowse,16,8,FALSE,FALSE,"Courier new");

	ShowWindow(hwndFileList,SW_HIDE);
	ShowWindow(hwndAddFile,SW_HIDE);
	ShowWindow(hwndDelFile,SW_HIDE);
	bBatchMode = FALSE;

	//add tick options
	y= 80;
	for(i=0; i < (sizeof(tickopts) / sizeof(_topts)) ; i++)
	{
		//add option
		hwnd = MWNDAddControl(mwndMainWindow,CONTROLTYPE_CHECKBOX,305,y,380,20,
							  tickopts[i].desc ,CONTROLRESIZE_MOVEY | CONTROLRESIZE_MOVEX,WindowEventCallback,
							  (LPVOID)tickopts[i].opt,(LPVOID)1);
		MWNDSetCheckedState(hwnd,GetSetting(tickopts[i].opt) != 0);
		MWNDSetControlFont(mwndMainWindow,hwnd,16,8,TRUE,FALSE,"Courier new");

		y += 25;
	}


	//add number options
	y+=30;
	for(i=0; i < (sizeof(numopts) / sizeof(_nopts)) ; i++)
	{
		//add  option
		hwnd = MWNDAddControl(mwndMainWindow,CONTROLTYPE_STATIC,305,y,270,20,numopts[i].desc,
							  CONTROLRESIZE_MOVEY | CONTROLRESIZE_RESIZEWIDTH | CONTROLRESIZE_MOVEX,NULL,0,0);
		MWNDSetControlFont(mwndMainWindow,hwnd,16,8,FALSE,FALSE,"Courier new");

		hwnd = MWNDAddControl(mwndMainWindow,CONTROLTYPE_EDITBOX,580,y,100,20,
							  tickopts[i].desc ,
							  CONTROLRESIZE_MOVEY | CONTROLRESIZE_MOVEX | CONTROLRESIZE_RESIZEWIDTH,
							  WindowEventCallback,
							  (LPVOID)numopts[i].opt,(LPVOID)2);
		MWNDSetControlFont(mwndMainWindow,hwnd,16,8,FALSE,FALSE,"Courier new");

		if (numopts[i].opt == SETTING_SKIPSIZE) 
		{
			MWNDSetTextNumber(hwnd,GetSetting(numopts[i].opt) / 10000);
		}
		else
		{
			MWNDSetTextNumber(hwnd,GetSetting(numopts[i].opt));
		}
	
		y += 25;
	}


	hwndButton = MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,430,y+10,220,25,RENDERBUTTON_OK,
								CONTROLRESIZE_MOVEY | CONTROLRESIZE_RESIZEWIDTH |CONTROLRESIZE_MOVEX,WindowEventCallback,0,0);
	MWNDSetControlFont(mwndMainWindow,hwndButton,20,10,FALSE,FALSE,"Courier new");

	hwndMode =  MWNDAddControl(mwndMainWindow,CONTROLTYPE_BUTTON,305,y+10,100,25,
							   "Batch Mode",CONTROLRESIZE_MOVEY | CONTROLRESIZE_RESIZEWIDTH |CONTROLRESIZE_MOVEX,
							   WindowEventCallback,0,0);
	MWNDSetControlFont(mwndMainWindow,hwndMode,16,8,FALSE,FALSE,"Courier new");
	
	
	//set custom msg 
	MWNDSetCustomMsgCallback(mwndMainWindow,HIMDRENDER_GO,WindowMsgCallback,NULL);
	MWNDSetCustomMsgCallback(mwndMainWindow,HIMDRENDER_BATCH,WindowMsgCallback,NULL);

	//get winlib to re-size / reposition stuff correctly
	SetWindowPos(MWNDGetHWND(mwndMainWindow),0,0,0,DEFAULT_WND_WIDTH,DEFAULT_WND_HEIGHT - 1,SWP_NOMOVE | SWP_NOOWNERZORDER);

	//and.... go!
	MWNDRunMsgLoop();


	MWNDUnregisterClass(mwndMainWindow);
	
	return 0;
}

